<!-- @format -->

# Optimized Graphic Presets for Kingdom Come Deliverance by OVNI

After publishing a few mods here at Nexus, I kept getting requests to update this mod. I have always refused, because I believe that by optimizing system- and user.cfg you can achieve a similar result. Another reason was certainly that at first, I thought it would be far beyond my capabilities. At some point I downloaded the mod and started to analyze it. The better I understood the structure and functionality of the mod, the more I became convinced that I should be able to provide a working update and so I asked OVNI for permission.

# Mod Description

Optimized Graphic Presets extends the game's advanced graphics settings and uses optimized presets to increase visual quality and performance.

# Features

- Enhanced advanced graphic setting
- Better performance and visual quality
- Enhanced anti-aliasing (temporal SMAA with jittering)
- Enhanced shadows (higher res + grass projects shadows)
- Optimized Presets (special preset for easier use with ENB and ReShade included)
- Disabled Rim lights

# Requirements

- KCD Flowgraph Hook - Updated https://www.nexusmods.com/kingdomcomedeliverance/mods/1140
- Game version 1.9.4 or +

# Game Launcher - Default folder locations

Before starting the installation, we should check where we can find the folders required for the installation. That's important since each game launcher uses a different directory structure

**Steam**

- Data: C:\Program Files (x86)\Steam\steamapps\common\KingdomComeDeliverance\Data
- Engine: C:\Program Files (x86)\Steam\steamapps\common\KingdomComeDeliverance\Engine
- Mods: C:\Program Files (x86)\Steam\steamapps\common\KingdomComeDeliverance\Mods

**Epic**

- Data: C:\Program Files (x86)\Epic Games\KingdomComeDeliverance\Data
- Engine: C:\Program Files (x86)\Epic Games\KingdomComeDeliverance\Engine
- Mods: C:\Program Files (x86)\Epic Games\KingdomComeDeliverance\Mods

**GoG Galaxy**

- Data: C:\Program Files (x86)\GOG Galaxy\Games\KingdomComeDeliverance\Data
- Engine: C:\Program Files (x86)\GOG Galaxy\Games\KingdomComeDeliverance\Engine
- Mods: C:\Program Files (x86)\GOG Galaxy\Games\KingdomComeDeliverance\Mods

# How to install

Before you start with the installation you should completely remove all previous versions of the mod. Check if you have installed **KCD Flowgraph Hook - Updated** because It is required for the correct functioning of **Optimized Graphic Presets**. **Don't use VMM (Vortex Mod Manager)** for the installation unless you know how to correctly perform manual installation with it.

- Extract the content of this package to your **"C:\Program Files (x86)\Steam\steamapps\common\KingdomComeDeliverance\Mods"** folder.
- Check that the extracted folder name is exactly **Optimized_Graphic_Presets**. Otherwise you will run into problems later on.
- Copy the file **engine_ogp.pak** from the **Optimized_Graphic_Presets/Engine** folder to the **C:\Program Files (x86)\Steam\steamapps\common\KingdomComeDeliverance\Engine\Optimized_Graphic_Presets\Engine** folder of your game
- Next head over to **C:\Program Files (x86)\Steam\steamapps\common\KingdomComeDeliverance\Data** open the file **pak.cfg** with an File-Editor of your choice
- After the line **engine\engine.pak** add on a new line **engine\engine_ogp.pak**. Save and close the file.

The main part of the installation is now done, and you can start the game. You should note that loading the game with this mod activated takes a few minutes longer than before (even longer if you use ENB/ReShade or both). Until the game has fully loaded, you may just see a black screen and hear the game music.
If you use VMM (Vortex Mod Manager) to install and manage your other mods, additional installation steps are required

- Open the file **mod_order.txt** from your **KingdomComeDeliverance/Mods** folder
- Move **KCD Flowgraph Hook** to the top of the list
- On a new line right after it add Optimized_Graphic_Presets

# How to update

Updating the mod is similar to installing it. However, some installation steps are not required

- Delete the **Optimized_Graphic_Presets** folder from your **KingdomComeDeliverance/Mods** directory
- Extract the content of the downloaded package to your **KingdomComeDeliverance/Mods** folder
- Check that the extracted folder name is exactly Optimized_Graphic_Presets
- Copy the file **engine_ogp.pak** from the **Optimized_Graphic_Presets/Engine** folder to the **KingdomComeDeliverance/Engine** folder of your game

# Limitations

Since the release of the mod by **OVNI**, the game has been consistently developed and updated. Unfortunately, it is not possible for me to fully trace back what exactly has changed over time to adapt the mod to these changes. Therefore, you may recognize some visual glitches relating to lighting effects and shadows.

# Compatibility

- Not compatible with mods that alter the files for **Graphic Settings** or **Advanced Graphics settings** menus.

# Future Releases

I don't want to give you a wrong impression here either, it was never planned that I would take over the further development of the mod. The aim of this update was always to fix existing problems to be able to offer a working version of the mod. I will not add any new features or implement suggestions made by you.

# Known Problems

**Gamma Slider**
The slider was removed with game version 1.5 and shouldn't be available with this mod activated.

- **PROBLEM:** You changed the gamma setting using the in-game menu, and now you have a persistent gamma issue on your desktop and in other games.
- **DETAILS:** CryEngine's r_Gamma CVar changes gamma at the hardware level, which affects the game, the HUD, and the desktop. Warhorse had no time to implement a software-level gamma control, so the in-game menu's gamma setting just changes the CVar. This is a known issue.
- **FIX:** Set r_Gamma to 1 and r_NoHWGamma to 1 in your user.cfg or simply use the control panel of your driver to adjust gamma settings.
- **REFERENCES:** r_Gamma, r_NoHWGamma

To get rid of the Gamma Slider it would be necessary to recreate the file MM_GraphicSettings.xml which controls the flowgraph nodes for the Graphics Menu. I did this once and it drove me nuts. You can mess up the functionality of the flowgraph with only one wrong edit. Using only an editor to manage the nodes is too confusing. I don't want to repeat that.

**mod.manifest**
The game skips the whole info block of the mod.manifest on load. Therefore, it is not possible to prevent the mod from loading if **KCD Flowgraph Hook - Updated** is not installed and loaded.

# Recommendations

- Whenever possible install the game on **SSD**. This will avoid most of the annoying texture pop ins
- Don't tweak your **system-** and / or **user.cfg** files unless you are sure that the used tweak(s) will work a 100% and that it won't mess up the settings applied by the mod
- If you have tweaked your **system-** and / or **user.cfg** already you should make sure that **r_TexturesStreamingMaxRequestedMB** isn't set above **2**. In most cases a higher value will lead to issues such as texture pop ins or textures not loading at all.
- Don''t use **sys_budget_sysmem** or **sys_budget_videomem** in your **user.cfg**. They are only for monitoring purposes and have no impact to the game performance!
- If you want to use **ENB** and have a nvidia GPU, you should deactivate **Ansel** before starting the game. If both are activated the game will crash on start.
- For the use with **ENB/ReShade** the **shader quality** must be set to **high** or **very high** as it is a requirement for both.
- If your PC is older than 3 years and you want to achieve a reliable performance, you should avoid using **ENB/ReShade** in combination with this mod (especially if you have not installed at least **16 GB of RAM** and **8 GB of VRAM**).
- Don't use programs such as **GeForce Experience** or **AMD Radeon Boost**. Their presets will conflict with the settings applied by this mod.
- Last but not least be careful with **System- or GameOptimizer** programs. Most of them are only placebo's and can lead to unexpected problems rather than having a positive effect on game performance

# Change Log

3.8.5

- MOD: Some more changes to the shadowcast of entity objects

3.8.4

- FIX: Added missing setting options for water and weather effects
- FIX: Fixed display of particles
- FIX: Fixed all presets which were loading wrong settings (hopefully)
- NEW: Added fix for flickering cauldron smoke
- NEW: Disabled shadow cast for candles, torches, and lanterns (to improve FPS at night)
- NEW: Added setting options for grass shadows
- MOD: Loading time has been improved
- MOD: Moved q_ShaderWater tp CVAR Group sys_spec_ogp_shading (and fixed settings for some presets)
- MOD: Reverted some changes made in ogp_console.lua with the last version
- MOD: Removed some presets which were added with the last version (they are not needed anymore)

3.8.3

- FIX: Fixed various setting options and how they are applied
- CHG: Changed how some variables are loaded with the ogp presets
- CHG: Added all motion blur settings to sys_spec_ogp_motionblur
- CHG: Added default cache settings to all ogp presets
- CHG: Added default dof settings to all ogp presets

3.8.2

- NEW: Added an ogp preset for very high settings (wip). Edited ogp_main.lua to reflect this change.
- FIX: Added missing CVarGroups (new ones) to ogp_console.lua (all settings should now be correctly logged).
- MOD: Completely reworked sys_spec_ogp_antialiasing.cfg. Removed all presets which were not used or didn't work. All others were compared with the cryengine documentation. TSAA should now work as intended.
- MOD: Reworked ogp presets a little bit. They are now linked to the different antialiasing settings.
- MOD: Enhanced sys_spec_ogp_gi.cfg (global illumination) with some parameters
- MOD: Cleaned up localization files and filled all tooltip variables with text
- MOD: Cleaned up CVarGroups and removed als sys_spec files which were not used or not necessary anymore
- MOD: Disabled Gamma-Slider and added r_Gamma = 1 and r_NoHWGamma = 1 to ogp_override.cfg
- MOD: Removed all previous entries from the ogp_override.cfg file. All parameters are now processed by CVarGroups and the values are set by the presets
- UPD: Updated README.md (this file)

3.8.1

- CHG: Changed r_DeferredShadingAreaLights to 1 in sys_spec_ogp_shading.cfg
- CHG: Changed SSAA settings in sys_spec_ogp_antialiasing.cfg to the recommended settings of the cryengine documentation
- UPD: Updated the README.md (this file)

3.8.0

- FIX: Fixed some tooltip related issues.
- NEW: Added a sample file for mod_order.txt (to demonstrate how a good load order should be organized)
- MOD: Changed the formatting of the CVarGroup files for better readability

3.7.9

- CHG: Added ogp_high_enb and ogp_vanilla_high_enb to presets in ogp_advancedSettingsMenu.xml (if they were required)
- CHG: Added presets for ogp_high_enb and ogp_vanilla_high_enb to presets (if they were required)
- CHG: Added ogp_high_enb and ogp_vanilla_high_enb to ogp_main.lua
- CHG: Moved user.cfg and system.cfg into the examples folder
- CHG: Removed all sys_budget settings from the sample user.cfg as they have no impact on game performance and are only used for monitoring purposes

3.7.8

- CHG: Removed some values from ogp_override.cfg (overriding mod settings isn't a good idea in my opinion)
- CHG: Removed e_ObjShadowCastSpec from all presets as it is set within "sys_spec_ogp_grass.cfg" and "sys_spec_ogp_grass_vanilla.cfg"
- CHG: Re-arranged ogp_advancedSettingsMenu.xml
- CHG: Changed available settings for r_sharpening (sys_spec_ogp_sharpening.cfg)
- CHG: Compared user.cfg sample against the CVarGroups and removed variables which are set by the mod
- UPD: README.md has been updated (mainly the Installation / Update Section but also some other areas)

3.7.7

- NEW: Added system.cfg and user.cfg samples (all values beginning with sys_ in user.cfg have to be set to the system hw)
- CHG: Changed the way how motion blur is saved
- CHG: Changed the way how r_sharpening is saved
- CHG: Changed the way how e_MergedMeshesUseSpines is saved
- CHG: Changed Antialiasing settings in obp_high_enb.cfg and ogp_vanilla_high_enb.cfg (for use with ENB Antialiasing has to be disabled)

3.7.6

- UPD: Updated mod.manifest for game version 1.9.6

3.7.5

- NEW: Added sys_spec_light=4 to ogp_override.cfg (thanks to gerard fraser for his input)

3.7.4

- CHG: Revised folder structure of the mod
- REM: Removed Flowgraph Hook from package
- REM: Removed force_native_fullscreen.pak from package
- REM: Removed Vsync Option from Advanced Graphic Settings as it is part of the Graphic Settings now
- FIX: Compatibility Fix for HD Textures
- CHG: Set e_VegetationMinSize=0 in all presets to fix mushrooms not being rendered
- CHG: Copied syspec_GameEffects values to the ogp weather files
- NEW: Added russian and german translation to the package.
- FIX: Workaround for CVarGroups not being copied to the Engines Folder after game starts
- UPD: Corrected Changelog to OVNI's output

3.7.3

- FIX: Fixed issue with shadow flickering nearby light sources.

3.7.2

- UPD: Updated to the latest version of the game: 1.9.0
- UPD: Updated hook (flowgraph) - https://www.nexusmods.com/kingdomcomedeliverance/mods/378
- FIX: Fixed main menu.
- FIX: Fixed issue with disappearing hud.

3.7.1

- FIX: texture button is now bound to correct cvargroup.

3.7.0

- NEW: Added German translation (thanks to Ravick)
- MOD: Exec ogp_override.cfg at start, before loading screen (some settings may or may not require to be set before assets/level loading).
- FIX: Removed ogp_override.cfg file from the zip, so it won't be overwritten when updating the mod.
- FIX: Simple graphics now correctly applies texture settings (except for low and ugly).

3.6.0

- MOD: better perf for volumetric fog (~6% more fps compared to previous setting)
- MOD: enabled volfog for high and ultra global presets

3.5.0

- NEW: 'ogp_override.cfg' is executed after loading/applying ogp settings.

3.4.0

- NEW: Replaced profile switch hotkeys in favor of an "instant boost" on(np1) and off (np0) hotkeys
- NEW: Enhanced (better looking) volumetric fog (disabled by default).
- MOD: Optimized weather profile: rain costs ~3% FPS less and drops are smaller.
- MOD: Added choice for the 3 vanilla weather profiles
- MOD: Reduced water choices to only one (other choices cost up to 5% FPS more without any visual difference).
- MOD: Increased object view distance for medium preset
- MOD: Right arrow key now enforces native fullscreen (just like D) for left-handers.
- FIX: Texture button's value is now always correct.

3.3.0

- NEW/FIX: Texture settings is now correctly applied (also fixes "texture setting stuck at lowest" bug)
- MOD: Simplified menu: no more confirmations. Makes flowSHARTs a bit less unmanageable... Plus actionscript behavior isn't the same in every menu anyway...
- MOD: When changing profile in the basic settings menu, texture is always set to medium. WONFIX (it would only lead to flowSHARTs chaos...), use advanced settings to change it.
- MOD: improved grass settings (increased grass-terrain color bending distance)

3.2.1

- FIX: Reset settings as they were where leaving adv settings menu without saving changes.
- FIX: Force LOD system to refresh sooner, in main menu ("Reload the game, I get washed (blur) background" bug)

3.2.0

- NEW: Save settings when leaving Simple Graphic Menu
- NEW: Added SMAA T2x without subsampling as flicker-free AA option
- MOD: SMAA2TxSS uses x3 subsampling (was x2 previously)
- FIX: "Loaded settings overridden by vanilla ones"
- FIX: 3 points lightning setting actual value / gui value mismatch
- FIX: clamp button choices, so buttons wont get an arbitrary value when there's no choice corresponding to cvar's value (eg: ogp_set_physics -5 made menu show Physics: Ugly instead of Medium (the highest choice) )
- FIX: ogp_set_cvar does not try to assign positive values to inexistent xxx_vanilla cvar (was causing inconstant sys_spec_ogp_dof_state value)
- FIX: "no sunshafts even when r_sunshafts=1"
- FIX: ambient occlusion typo
- FIX: removed false-alarm error log when setting custom profile from (simple) graphic setting menu.

3.1.0

- FIX: "Settings aren't saved" issue on Windows10
- FIX: ogp_set_3pl console command now works (to apply 3point lightning settings)
- MOD: Settings are now loaded from lua instead of flowgraph
- MOD: Removed ogp_setup.bat (symb link no longer needed)

3.0.2

- FIX: 75, 95, 100 fov settings

3.0.1

- FIX: Misleading outdated error message in ogp_setup.bat

3.0.0

- NEW: Shadows use highest lod (makes lod transition smoother a little)
- NEW: Can set all-in-one profile in (standard) graphic menu.
- NEW: Can change sub-profiles in advanced graphic menu
- NEW: Settings load/saving from user profile
- NEW: In adv Graphic Menu, disabled DoF and vignette effect to see applied changes.
- NEW: Adv Graphic Menu contains 13 options instead of 7
- NEW: in Adv Graphic Menu, Apply does not require confirmation.
- NEW: more SSDO presets (old one is "strong").
- NEW: Unlimited range for rainy/wet terrain shader (practically free, and the seam looked weird).
- NEW: Added baked GI setting, replaces GI off (which made barns and interiors pitch black).
- NEW: Extended FOV choices
- NEW: texture sub-profile with consistent anisotropic values.
- NEW: drunk sharpening on/off
- NEW: 3PL on/off
- NEW: grass wind on/off
- NEW: DoF on/off
- MOD: Hotkeys are set using lua to avoid using user.cfg (also mod.cfg is broken...)
- MOD: Decoupled some settings (AA, motionblur, grass wind, etc.) from profiles so they can be set on their own.
- MOD: Reduced GI flickering even more.
- MOD: GI Settings closer to vanilla look (except baked).
- MOD: Kept only shadows settings with best quality/cost ratio, reduced flickering with lower setting.
- MOD: Redone grass, traded distance for fewer pop-in.
- FIX: "ugly preset crashing game"
- FIX: "Ultra preset typos"
- FIX: "heads disappearing using ugly preset"

2.3

- BUGFIX commented vsync off in user.cfg
- BUGFIX typo ( \`e_UberlodDistanceRatio )
- BUGFIX fixed "ugly preset crashing game" issue
- top-level profiles are now cfg files instead of var groups.
- always use e_svoti_ResScaleBase=0, modify e_svoti_LowSpecMode instead.
- added missing ultra preset for shading
- added missing ultra preset for GI
- e_ViewDistMin=40 instead of 50 for ultra
- removed e_UberlodActivate from var groups (had no effect there)
- added e_UberlodActivate in user.cfg
- reduced svoTI saturation
- added more commented tweaks in user.cfg
- replaced readme.txt by README.md

2.21

- bugfix highest preset uses highest settings (ultra was the same as high except for lod)
- shadow presets : r_ShadowCastingLightsMaxCount 0/10/15/20/25 instead of 3 for all (caused shadow flickering because engine looks to randomly pick light...)
- moved d and esc hotkey to user.cfg (so user can disable them)
- increased e_ViewDistMin for low and medium lod presets

2.2

- hopefully fixed blackface
- fixed some shadow flickering
- added CVarGroups to revert vanilla settings for each categories.
- disabled r_VolumetricFogSunLightCorrection (effect only visible if volfog enabled).
- reduced max shadow sources to 3 (should improve perfs vs npcs with torches)
- ugly presets is less ugly (enabled grass-terrain color blending + ssdo + less obvious grass popup), costs ~5% FPS more.
- added a new profile (low had became too heavy)
- increased ssdo str, reduced min radius (so shadow-less glass looks better).
- non-ugly presets use r_AntialiasingTAAPattern (better subsampling)

2.1

- bugfix: low grass preset disabling trees shadows
- shadows settings improvement

2.0

- Added multiple CVarGroups
- Does not reset every settings (physics, etc.)
- All presets use higher rendering quality (better normal mapping / POM / etc.)
- GI cascade lod 5 instead of 4 (vanilla was 2) to reduce flickering even more and marginally increase framerate.
- GI settings should hopefully no longer generate black eyes
- Tweaked shadows for each preset.
- Tweaked grass for each preset.
- Added hotkeys to switch individual sub-presets
- Reduced preset number to only 4 (was 5).

1.31

- fixed black eyes

1.3

- interiors are darker (than presets v1.2, it's still a bit brighter than vanilla tho)
- increased ambient occlusion amount
- fixed black eyes
- ugly now show grass (very few)
- ugly now always use lowest lod models
- low preset is faster (should be on pair with vanilla low preset)

1.21

- minor global illumination settings tweaks

1.2

- disabled global illumination for ugly presets. As a result you will have to use torches more often but the fps boost is quite huge.
- made the "dark blocks" less visible without impacting framerate too much. (may even boost quality for higher preset in the future)
- doubled the amount of cascades for GI, so it stop flickering due to resolution being to low.
- added hotkeys to change presets
- d key enables native fullscreen

1.1

- disabled motionblur
